"sunflower" <- function(dat,xnames,ynames,cutoff)
{
# Makes sunflower plot of Constantia data
# dat must be data frame with columns x,y,number
# xnames must be a factor, ynames must be a factor
# (so that xnames[5] returns 5th entry)

# Based on R-2.5.0/etc/Rdevga file
font.nums <- 8

x.out <- 1.75
y.in <- 2.4
fnt.cex <- 1

plotdat <- dat

# Only plot characters that have been confused
# cutoff or more times:
plotdat <- plotdat[plotdat$number >= cutoff,]

# For axis labels:
numlabelx <- as.numeric(levels(as.factor(plotdat$x)))
numlabely <- as.numeric(levels(as.factor(plotdat$y)))
xnames <- xnames[numlabelx]
ynames <- ynames[numlabely]

# Save file as png after it is on screen
windows(pointsize=10)

# Various plot parameters:
par(bg="white",xpd=T,las=1)

sunflowerplot(plotdat$x,plotdat$y,plotdat$number,xlab="Character Presented",
                ylab="Character Reported",main="Consolas",axes=F,
                seg.col="blue",seg.lwd=3,font.lab=font.nums,
                font.main=font.nums)

axis(1,numlabelx,labels=xnames,font=font.nums,cex=fnt.cex)

axis(2,numlabely,labels=ynames,font=font.nums,cex=fnt.cex)

# To get the divide sign:
text(numlabelx[xnames==""],x.out,labels="\xF7",font=font.nums,
     cex=fnt.cex)
text(y.in,numlabely[ynames==""],labels="\xF7",font=font.nums,
     cex=fnt.cex)

# Background labels set by hand,
# with commands such as:
#mygrey <- rgb(red=1,blue=1,green=1,alpha=15,max=255)
#lines(c(17.5,17.5),c(-0.5,53.5))
#lines(c(1,52),c(20.5,20.5))
#text(6,8,"SS",col=mygrey,cex=5)
#text(17.25,8,"NS",col=mygrey,cex=5)
#text(29.5,8,"LS",col=mygrey,cex=5)
#lines(c(27.5,27.5),c(0,54))
#lines(c(1,52),c(30.5,30.5))
#text(6,19,"SN",col=mygrey,cex=5)
#text(17.25,19,"NN",col=mygrey,cex=5)
#text(29.5,19,"LN",col=mygrey,cex=5)
#text(6,30,"SL",col=mygrey,cex=5)
#text(17.5,30,"NL",col=mygrey,cex=5)
#text(29.5,30,"LL",col=mygrey,cex=5)

}

  
